/*
DCBouncer: bouncer / proxy for Direct Connect networks.
Copyright (C) 2008-2017 poy <poy@123gen.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef DCBOUNCER_CLIENT_H
#define DCBOUNCER_CLIENT_H

#include "Sockets/TcpSocket.h"

class EventHandler;

class Client : public sockets::TcpSocket
{
public:
	Client(sockets::ISocketHandler&);

	void Init();
	void InitSSLServer();
	void OnAccept();
	void OnRawData(const char*, size_t);
	void OnDelete();

	typedef std::vector<std::string> authorized_type;
	static authorized_type authorized;

private:
	const EventHandler& Handler() const;
	EventHandler& Handler();
};

#endif
