/*
DCBouncer: bouncer / proxy for Direct Connect networks.
Copyright (C) 2008-2017 poy <poy@123gen.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef DCBOUNCER_NMDCHANDLER_H
#define DCBOUNCER_NMDCHANDLER_H

#include "Proxy.h"

class NMDCHandler : public Proxy
{
public:
	explicit NMDCHandler(EventHandler&, const Profile&);

private:
	struct Client_info
	{
		Client_info() { }

		void clear();

		std::string supports;
		std::string key;
		std::string validate;
		std::string pass;
		std::string my_info;
	} client_info;

	struct Hub_info
	{
		Hub_info() { }

		void clear();

		std::string lock;
		std::string supports;
		std::string pass;
		std::string hello;

		std::string name;

		typedef std::vector<std::string> cmds_type;
		cmds_type cmds;

		typedef std::vector<std::string> ips_type;
		ips_type ips;
	} hub_info;

	typedef std::vector<std::string> logs_type;
	logs_type logs;

	void checkClientValidate();

	// Proxy
	char separator() const;
	void clientConnected();
	void clientCommand(const std::string&);
	void hubCommand(const std::string&);
	void clearHubInfo();
	void sendCommand(const std::string&, const std::string&);
	void sendMessage(const std::string&);
	void offlineDescription(const std::string&);
};

#endif
