#
# spec file for package DCBouncer
#
# Copyright (C) 2008-2017 poy <poy@123gen.com>
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

Name:          DCBouncer
Summary:       Bouncer / proxy for Direct Connect networks
Version:       __VERSION__
Release:       0
License:       GPL-2.0+
Group:         Productivity/Networking/File-Sharing
URL:           https://launchpad.net/dcbouncer
Source:        DCBouncer-%{version}-source.tar.gz
BuildRequires: gcc-c++
BuildRequires: openssl-devel

%description
DCBouncer is a bouncer / proxy for Direct Connect networks (used by DC++). It's
a little program that you start up on your remote server, and that stays
connected all the time to your favorite hubs. Instead of connecting to the hub
directly, you connect to DCBouncer (residing on your remote server) and
DCBouncer connects to the hub. DCBouncer then ensures communication between you
and the hub. While you are offline, DCBouncer stays connected to the hub and it
logs messages that you miss; then when you log back in, it forwards them all
back to you.

DCBouncer supports both the ADC <http://adc.sourceforge.net> and the (old) NMDC
protocols.
DCBouncer supports secure TLS connections.

DCBouncer uses:
- Anders Hedström's C++ Sockets Library <http://www.alhem.net/Sockets/> for its
  networking functions.
- Jacek Sieka's DC++ <http://dcplusplus.sourceforge.net> for some ADC
  functions.

Take a look at the included "README" file for more information.

Feel free to use the Launchpad interface for this project
<https://launchpad.net/dcbouncer> or e-mail me directly <poy@123gen.com> for
any feedback / suggestion / bug.

%prep
%setup -q -n DCBouncer-%{version}-source

%build
make

%install
mkdir -p %{buildroot}/%{_bindir} %{buildroot}/%{_sysconfdir}
install bin/DCBouncer %{buildroot}/%{_bindir}/DCBouncer
install etc/DCBouncer_default %{buildroot}/%{_sysconfdir}/DCBouncer
install etc/DCBouncer_default %{buildroot}/%{_sysconfdir}/DCBouncer_default

%files
%doc gpl-2.0.txt LICENSE README
%config(noreplace) %{_sysconfdir}/DCBouncer
%config %{_sysconfdir}/DCBouncer_default
%{_bindir}/DCBouncer

%changelog
